Index: code/branches/FICN/src/audio/AudioPrereqs.h
===================================================================
--- code/branches/FICN/src/audio/AudioPrereqs.h	(revision 774)
+++ code/branches/FICN/src/audio/AudioPrereqs.h	(revision 777)
@@ -27,5 +27,5 @@
 
 /**
- @file  OrxonoxPrereq.cc
+ @file  AudioPrereqs.h
  @brief Contains all the necessary forward declarations for all classes, structs and enums.
  */
@@ -59,6 +59,10 @@
 // Forward declarations
 //-----------------------------------------------------------------------
-namespace loader {
-  class LevelAudio;
+namespace audio
+{
+  class AudioBuffer;
+  class AudioManager;
+  class AudioSource;
+  class AudioStream;
 }
 
Index: code/branches/FICN/src/network/Client.cc
===================================================================
--- code/branches/FICN/src/network/Client.cc	(revision 774)
+++ code/branches/FICN/src/network/Client.cc	(revision 777)
@@ -1,28 +1,28 @@
 /*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Oliver Scheuss, (C) 2007
- *   Co-authors:
- *      ...
- *
- */
+*   ORXONOX - the hottest 3D action shooter ever to exist
+*
+*
+*   License notice:
+*
+*   This program is free software; you can redistribute it and/or
+*   modify it under the terms of the GNU General Public License
+*   as published by the Free Software Foundation; either version 2
+*   of the License, or (at your option) any later version.
+*
+*   This program is distributed in the hope that it will be useful,
+*   but WITHOUT ANY WARRANTY; without even the implied warranty of
+*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*   GNU General Public License for more details.
+*
+*   You should have received a copy of the GNU General Public License
+*   along with this program; if not, write to the Free Software
+*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+*
+*   Author:
+*      Oliver Scheuss, (C) 2007
+*   Co-authors:
+*      ...
+*
+*/
 
 //
@@ -38,12 +38,13 @@
 //
 
+#include "core/CoreIncludes.h"
 #include "Client.h"
 
-namespace network{
-
-  /**
-   * Constructor for the Client class
-   * initializes the address and the port to default localhost:NETWORK_PORT
-   */
+namespace network
+{
+  /**
+  * Constructor for the Client class
+  * initializes the address and the port to default localhost:NETWORK_PORT
+  */
   Client::Client(): client_connection(NETWORK_PORT,"127.0.0.1"){
     // set server address to localhost
@@ -52,8 +53,8 @@
 
   /**
-   * Constructor for the Client class
-   * @param address the server address
-   * @param port port of the application on the server
-   */
+  * Constructor for the Client class
+  * @param address the server address
+  * @param port port of the application on the server
+  */
   Client::Client(std::string address, int port) : client_connection(port, address){
     isConnected=false;
@@ -61,8 +62,8 @@
 
   /**
-   * Constructor for the Client class
-   * @param address the server address
-   * @param port port of the application on the server
-   */
+  * Constructor for the Client class
+  * @param address the server address
+  * @param port port of the application on the server
+  */
   Client::Client(const char *address, int port) : client_connection(port, address){
     isConnected=false;
@@ -70,7 +71,7 @@
 
   /**
-   * Establish the Connection to the Server
-   * @return true/false
-   */
+  * Establish the Connection to the Server
+  * @return true/false
+  */
   bool Client::establishConnection(){
     isConnected=client_connection.createConnection();
@@ -79,7 +80,7 @@
 
   /**
-   * closes the Connection to the Server
-   * @return true/false
-   */
+  * closes the Connection to the Server
+  * @return true/false
+  */
   bool Client::closeConnection(){
     isConnected=false;
@@ -88,9 +89,9 @@
 
   /**
-   * submits a MouseAction to the server
-   * @param x x Coordinate
-   * @param y y Coordinate
-   * @return true/false
-   */
+  * submits a MouseAction to the server
+  * @param x x Coordinate
+  * @param y y Coordinate
+  * @return true/false
+  */
   bool Client::sendMouse(double x, double y){
     // generate packet and add it to the queue
@@ -98,5 +99,5 @@
       return false;
     if(!client_connection.addPacket(pck_gen.mousem(x, y)))
-        return false;
+      return false;
     // send packets
     return client_connection.sendPackets();
@@ -104,8 +105,8 @@
 
   /**
-   * submits a Keystrike to the server
-   * @param key_code code to submit
-   * @return true/false
-   */
+  * submits a Keystrike to the server
+  * @param key_code code to submit
+  * @return true/false
+  */
   bool Client::sendKeyboard(char key_code){
     // generate packet and add it to queue
@@ -113,5 +114,5 @@
       return false;
     if(!client_connection.addPacket(pck_gen.keystrike(key_code)))
-        return false;
+      return false;
     // send packets
     return client_connection.sendPackets();
@@ -119,8 +120,8 @@
 
   /**
-   * submits a chat message to the server
-   * @param message message to send
-   * @return true/false
-   */
+  * submits a chat message to the server
+  * @param message message to send
+  * @return true/false
+  */
   bool Client::sendChat( std::string message ){
     // generate packet and add it to queue
@@ -134,9 +135,9 @@
 
   /**
-   * Adds a MouseAction to the PacketQueue
-   * @param x x Coordinate
-   * @param y y Coordinate
-   * @return true/false
-   */
+  * Adds a MouseAction to the PacketQueue
+  * @param x x Coordinate
+  * @param y y Coordinate
+  * @return true/false
+  */
   bool Client::addMouse(double x, double y){
     // generate packet and add it to the queue
@@ -148,8 +149,8 @@
 
   /**
-   * Adds a Keystrike to the PacketQueue
-   * @param key_code
-   * @return true/false
-   */
+  * Adds a Keystrike to the PacketQueue
+  * @param key_code
+  * @return true/false
+  */
   bool Client::addKeyboard(char key_code){
     // generate packet and add it to queue
@@ -161,6 +162,6 @@
 
   /**
-   * Sends out all the packets queued by addXXX
-   */
+  * Sends out all the packets queued by addXXX
+  */
   bool Client::sendPackets(){
     if(!isConnected)
@@ -176,6 +177,6 @@
 
   /**
-   * Performs a GameState update
-   */
+  * Performs a GameState update
+  */
   void Client::tick(float time){
     ENetPacket *packet;
Index: code/branches/FICN/src/network/Client.h
===================================================================
--- code/branches/FICN/src/network/Client.h	(revision 774)
+++ code/branches/FICN/src/network/Client.h	(revision 777)
@@ -16,53 +16,51 @@
 #include <string>
 
+#include "NetworkPrereqs.h"
 #include "ClientConnection.h"
 #include "PacketManager.h"
 #include "GameStateClient.h"
-#include "core/CoreIncludes.h"
 //#include "NetworkFrameListener.h"
 
 
-namespace network{
+namespace network
+{
+  /**
+  network::Client *client;
+  * The network/Client class
+  * This class implements all necessary function for the network communication
+  * It is the root class of the network module
+  *
+  */
+  class _NetworkExport Client : PacketDecoder{
+  public:
+    Client();
+    Client(std::string address, int port);
+    Client(const char *address, int port);
 
+    bool establishConnection();
+    bool closeConnection();
 
-  
-/**
-  network::Client *client;
- * The network/Client class
- * This class implements all necessary function for the network communication
- * It is the root class of the network module
- *
- */
-class Client : PacketDecoder{
-  public:
-  Client();
-  Client(std::string address, int port);
-  Client(const char *address, int port);
+    bool sendMouse(double x, double y);
+    bool sendKeyboard(char key_code);
+    bool sendChat( std::string message );
 
-  bool establishConnection();
-  bool closeConnection();
+    bool addMouse(double x, double y);
+    bool addKeyboard(char key_code);
 
-  bool sendMouse(double x, double y);
-  bool sendKeyboard(char key_code);
-  bool sendChat( std::string message );
+    bool sendPackets();
 
-  bool addMouse(double x, double y);
-  bool addKeyboard(char key_code);
-
-  bool sendPackets();
-  
-  void tick(float time);
+    void tick(float time);
 
   private:
-  ClientConnection client_connection;
-  PacketGenerator pck_gen;
-  GameStateClient gamestate;
-  bool isConnected;
-  
-  // implement data processing functions of PacketDecoder
-  void processGamestate( GameStateCompressed *data);
-  void processClassid(classid *clid);
-  void processChat( chat *data);
-};
+    ClientConnection client_connection;
+    PacketGenerator pck_gen;
+    GameStateClient gamestate;
+    bool isConnected;
+
+    // implement data processing functions of PacketDecoder
+    void processGamestate( GameStateCompressed *data);
+    void processClassid(classid *clid);
+    void processChat( chat *data);
+  };
 
 
Index: code/branches/FICN/src/network/ClientConnection.cc
===================================================================
--- code/branches/FICN/src/network/ClientConnection.cc	(revision 774)
+++ code/branches/FICN/src/network/ClientConnection.cc	(revision 777)
@@ -1,28 +1,28 @@
 /*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Oliver Scheuss, (C) 2007
- *   Co-authors:
- *      ...
- *
- */
+*   ORXONOX - the hottest 3D action shooter ever to exist
+*
+*
+*   License notice:
+*
+*   This program is free software; you can redistribute it and/or
+*   modify it under the terms of the GNU General Public License
+*   as published by the Free Software Foundation; either version 2
+*   of the License, or (at your option) any later version.
+*
+*   This program is distributed in the hope that it will be useful,
+*   but WITHOUT ANY WARRANTY; without even the implied warranty of
+*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*   GNU General Public License for more details.
+*
+*   You should have received a copy of the GNU General Public License
+*   along with this program; if not, write to the Free Software
+*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+*
+*   Author:
+*      Oliver Scheuss, (C) 2007
+*   Co-authors:
+*      ...
+*
+*/
 
 //
@@ -37,13 +37,17 @@
 //
 
+#include <iostream>
+// boost.thread library for multithreading support
+#include <boost/thread/thread.hpp>
+#include <boost/bind.hpp>
+
+#include "util/Sleep.h"
 #include "ClientConnection.h"
 
-#include "util/Sleep.h"
-
-namespace network{
-
+namespace network
+{
   static boost::thread_group network_threads;
 
-  ClientConnection::ClientConnection(int port, std::string address){
+  ClientConnection::ClientConnection(int port, std::string address) {
     quit=false;
     server=NULL;
@@ -53,5 +57,5 @@
   }
 
-  ClientConnection::ClientConnection(int port, const char *address){
+  ClientConnection::ClientConnection(int port, const char *address) {
     quit=false;
     server=NULL;
@@ -61,5 +65,5 @@
   }
 
-  bool ClientConnection::waitEstablished(int milisec){
+  bool ClientConnection::waitEstablished(int milisec) {
     for(int i=0; i<=milisec && !established; i++)
       usleep(1000);
@@ -69,5 +73,5 @@
 
 
-  ENetPacket *ClientConnection::getPacket(ENetAddress &address){
+  ENetPacket *ClientConnection::getPacket(ENetAddress &address) {
     if(!buffer.isEmpty()) {
       //std::cout << "###BUFFER IS NOT EMPTY###" << std::endl;
@@ -75,18 +79,18 @@
     }
     else{
-        return NULL;
-    }
-  }
-
-  ENetPacket *ClientConnection::getPacket(){
+      return NULL;
+    }
+  }
+
+  ENetPacket *ClientConnection::getPacket() {
     ENetAddress address;
     return getPacket(address);
   }
 
-  bool ClientConnection::queueEmpty(){
+  bool ClientConnection::queueEmpty() {
     return buffer.isEmpty();
   }
 
-  bool ClientConnection::createConnection(){
+  bool ClientConnection::createConnection() {
     network_threads.create_thread(boost::bind(boost::mem_fn(&ClientConnection::receiverThread), this));
     // wait 10 seconds for the connection to be established
@@ -94,5 +98,5 @@
   }
 
-  bool ClientConnection::closeConnection(){
+  bool ClientConnection::closeConnection() {
     quit=true;
     network_threads.join_all();
@@ -102,5 +106,5 @@
 
 
-  bool ClientConnection::addPacket(ENetPacket *packet){
+  bool ClientConnection::addPacket(ENetPacket *packet) {
     if(server==NULL)
       return false;
@@ -110,5 +114,5 @@
   }
 
-  bool ClientConnection::sendPackets(ENetEvent *event){
+  bool ClientConnection::sendPackets(ENetEvent *event) {
     if(server==NULL)
       return false;
@@ -119,5 +123,5 @@
   }
 
-  bool ClientConnection::sendPackets(){
+  bool ClientConnection::sendPackets() {
     ENetEvent event;
     if(server==NULL)
@@ -129,5 +133,5 @@
   }
 
-  void ClientConnection::receiverThread(){
+  void ClientConnection::receiverThread() {
     // what about some error-handling here ?
     enet_initialize();
@@ -170,10 +174,10 @@
 
     if(!disconnectConnection())
-    // if disconnecting failed destroy conn.
+      // if disconnecting failed destroy conn.
       enet_peer_reset(server);
     return;
   }
 
-  bool ClientConnection::disconnectConnection(){
+  bool ClientConnection::disconnectConnection() {
     ENetEvent event;
     enet_peer_disconnect(server, 0);
@@ -181,11 +185,11 @@
       switch (event.type)
       {
-	case ENET_EVENT_TYPE_NONE:
-	case ENET_EVENT_TYPE_CONNECT:
-        case ENET_EVENT_TYPE_RECEIVE:
-          enet_packet_destroy(event.packet);
-          break;
-        case ENET_EVENT_TYPE_DISCONNECT:
-          return true;
+      case ENET_EVENT_TYPE_NONE:
+      case ENET_EVENT_TYPE_CONNECT:
+      case ENET_EVENT_TYPE_RECEIVE:
+        enet_packet_destroy(event.packet);
+        break;
+      case ENET_EVENT_TYPE_DISCONNECT:
+        return true;
       }
     }
@@ -194,5 +198,5 @@
   }
 
-  bool ClientConnection::establishConnection(){
+  bool ClientConnection::establishConnection() {
     ENetEvent event;
     // connect to peer
@@ -210,5 +214,5 @@
   }
 
-  bool ClientConnection::processData(ENetEvent *event){
+  bool ClientConnection::processData(ENetEvent *event) {
     //std::cout << "got packet, pushing to queue" << std::endl;
     // just add packet to the buffer
@@ -217,4 +221,3 @@
   }
 
-
 }
Index: code/branches/FICN/src/network/ClientConnection.h
===================================================================
--- code/branches/FICN/src/network/ClientConnection.h	(revision 774)
+++ code/branches/FICN/src/network/ClientConnection.h	(revision 777)
@@ -13,17 +13,13 @@
 #define _ClientConnection_H__
 
-#include <iostream>
 #include <string>
-// enet library for networking support
 #include <enet/enet.h>
-// boost.thread library for multithreading support
-#include <boost/thread/thread.hpp>
-#include <boost/bind.hpp>
-// headerfile
-#include "ClientConnection.h"
+
+#include "NetworkPrereqs.h"
 #include "PacketBuffer.h"
 
-namespace network{
-  //
+namespace network
+{
+
 #define NETWORK_PORT 55556
 #define NETWORK_CLIENT_MAX_CONNECTIONS 5
@@ -34,5 +30,5 @@
 
   class ClientConnection{
-    public:
+  public:
     ClientConnection(int port, std::string address);
     ClientConnection(int port, const char* address);
@@ -51,5 +47,5 @@
     bool sendPackets(ENetEvent *event);
     bool waitEstablished(int milisec);
-    private:
+  private:
     bool processData(ENetEvent *event);
     // implementation of the listener
Index: code/branches/FICN/src/network/ClientInformation.cc
===================================================================
--- code/branches/FICN/src/network/ClientInformation.cc	(revision 774)
+++ code/branches/FICN/src/network/ClientInformation.cc	(revision 777)
@@ -1,28 +1,28 @@
 /*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      ...
- *   Co-authors:
- *      ...
- *
- */
+*   ORXONOX - the hottest 3D action shooter ever to exist
+*
+*
+*   License notice:
+*
+*   This program is free software; you can redistribute it and/or
+*   modify it under the terms of the GNU General Public License
+*   as published by the Free Software Foundation; either version 2
+*   of the License, or (at your option) any later version.
+*
+*   This program is distributed in the hope that it will be useful,
+*   but WITHOUT ANY WARRANTY; without even the implied warranty of
+*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*   GNU General Public License for more details.
+*
+*   You should have received a copy of the GNU General Public License
+*   along with this program; if not, write to the Free Software
+*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+*
+*   Author:
+*      ...
+*   Co-authors:
+*      ...
+*
+*/
 
 //
@@ -37,195 +37,197 @@
 //
 //
+
+#include <iostream> //debug
+
 #include "ClientInformation.h"
 
-namespace network {
-
-ClientInformation::ClientInformation()
+namespace network
 {
-  gamestateID_=GAMESTATEID_INITIAL;
-  preve=0;
-  nexte=0;
-  this->head=false;
-  synched_=false;
+  ClientInformation::ClientInformation() {
+    gamestateID_=GAMESTATEID_INITIAL;
+    preve=0;
+    nexte=0;
+    this->head=false;
+    synched_=false;
+  }
+
+  ClientInformation::ClientInformation(bool head) {
+    gamestateID_=GAMESTATEID_INITIAL;
+    preve=0;
+    nexte=0;
+    this->head=head;
+    synched_=false;
+  }
+
+  // ClientInformation::ClientInformation(ClientInformation *prev) {
+  //   if(prev->next()!=0){
+  //     this->nexte=prev->next();
+  //     this->nexte->setPrev(this);
+  //   }
+  //   else
+  //     this->nexte = 0;
+  //   prev->setNext(this);
+  //   this->preve = pref;
+  // }
+  //
+  // ClientInformation::ClientInformation(ClientInformation *prev, ClientInformation *next){
+  //   this->nexte = next;
+  //   this->preve = prev;
+  //   this->preve->setNext(this);
+  //   this->nexte->setPrev(this);
+  // }
+
+  ClientInformation::~ClientInformation() {
+    if(preve!=0)
+      preve->setNext(this->nexte);
+    if(nexte!=0)
+      nexte->setPrev(this->preve);
+  }
+
+  ClientInformation *ClientInformation::next() {
+    if(this!=0)
+      return this->nexte;
+    else
+      return 0;
+  }
+  ClientInformation *ClientInformation::prev() {
+    if(this!=0)
+      return this->preve;
+    else
+      return 0;
+  }
+
+  bool ClientInformation::setPrev(ClientInformation *prev) {
+    if(!head)
+      this->preve = prev;
+    else
+      return false;
+    return true;
+  }
+
+  bool ClientInformation::setNext(ClientInformation *next) {
+    this->nexte = next;
+    return true;
+  }
+
+  ClientInformation *ClientInformation::insertAfter(ClientInformation *ins) {
+    this->nexte->setPrev(ins);
+    ins->setNext(this->nexte);
+    ins->setPrev(this);
+    this->nexte = ins;
+    return ins;
+  }
+
+  ClientInformation *ClientInformation::insertBefore(ClientInformation *ins){
+    this->prev()->setNext(ins);
+    ins->setPrev(this->preve);
+    this->preve=ins;
+    ins->setNext(this);
+    return ins;
+  }
+
+  void ClientInformation::setID(int clientID){
+    clientID_ = clientID;
+  }
+
+  void ClientInformation::setPeer(ENetPeer *peer){
+    peer_ = peer;
+  }
+
+  void ClientInformation::setGamestateID(int id){
+    gamestateID_=id;
+  }
+
+  int ClientInformation::getID() {
+    return clientID_;
+  }
+
+  ENetPeer *ClientInformation::getPeer() {
+    return peer_;
+  }
+
+  int ClientInformation::getGamestateID() {
+    return gamestateID_;
+  }
+
+  ClientInformation *ClientInformation::insertBack(ClientInformation *ins) {
+    ClientInformation *temp = this;
+    while(temp->next()!=0){
+      temp = temp->next();
+    }
+    temp->setNext(ins);
+    ins->setPrev(temp);
+    return ins;
+  }
+
+  bool ClientInformation::removeClient(int clientID) {
+    ClientInformation *temp = this;
+    while(temp!=0 && temp->getID()!=clientID)
+      temp = temp->next();
+    if(temp==0)
+      return false;
+    delete temp;
+    return true;
+  }
+
+  bool ClientInformation::removeClient(ENetPeer *peer) {
+    ClientInformation *temp = this;
+    while(temp!=0){
+      if(!temp->head)
+        if(temp->getPeer()->address.host==peer->address.host && temp->getPeer()->address.port==peer->address.port)
+          break;
+      temp = temp->next();
+    }
+    if(temp==0)
+      return false;
+    delete temp;
+    return true;
+  }
+
+  /**
+  * This function goes forward through the list and looks for an element with clientID
+  * This function should only be applied to the head of the list
+  * @param clientID id to look for
+  * @return pointer to the element in the list or 0 if the search was unsuccessfull
+  */
+  ClientInformation *ClientInformation::findClient(int clientID, bool look_backwards) {
+    ClientInformation *temp = this;
+    if (temp->head)
+      temp=temp->next();
+    while(temp!=0 && temp->getID()!=clientID){
+      temp = temp->next();
+    }
+    // returns 0 if nothing has been found
+    return temp;
+  }
+
+  /**
+  * This function goes forward through the list and looks for an element with clientID
+  * This function should only be applied to the head of the list
+  * @param peer peer to look for
+  * @return pointer to the element in the list
+  */
+  ClientInformation *ClientInformation::findClient(ENetAddress *address, bool look_backwards) {
+    ClientInformation *temp = this;
+    while(temp!=0){
+      if(temp->head){
+        temp = temp->next();
+        continue;
+      }
+      if(temp->getPeer()->address.host==address->host && temp->getPeer()->address.port == address->port)
+        break;
+      temp = temp->next();
+    }
+    // returns 0 if nothing has been found
+    return temp;
+  }
+
+  void ClientInformation::setSynched(bool s) {
+    synched_=s;
+  }
+
+  bool ClientInformation::getSynched() {
+    return synched_;
+  }
+
 }
-
-ClientInformation::ClientInformation(bool head)
-{
-  gamestateID_=GAMESTATEID_INITIAL;
-  preve=0;
-  nexte=0;
-  this->head=head;
-  synched_=false;
-}
-//
-
-// ClientInformation::ClientInformation(ClientInformation *prev){
-//   if(prev->next()!=0){
-//     this->nexte=prev->next();
-//     this->nexte->setPrev(this);
-//   }
-//   else
-//     this->nexte = 0;
-//   prev->setNext(this);
-//   this->preve = pref;
-// }
-//
-// ClientInformation::ClientInformation(ClientInformation *prev, ClientInformation *next){
-//   this->nexte = next;
-//   this->preve = prev;
-//   this->preve->setNext(this);
-//   this->nexte->setPrev(this);
-// }
-
-ClientInformation::~ClientInformation()
-{
-  if(preve!=0)
-    preve->setNext(this->nexte);
-  if(nexte!=0)
-    nexte->setPrev(this->preve);
-}
-
-ClientInformation *ClientInformation::next(){
-  if(this!=0)
-    return this->nexte;
-  else
-    return 0;
-}
-ClientInformation *ClientInformation::prev(){
-  if(this!=0)
-    return this->preve;
-  else
-    return 0;
-}
-
-bool ClientInformation::setPrev(ClientInformation *prev){
-  if(!head)
-    this->preve = prev;
-  else
-    return false;
-  return true;
-}
-
-bool ClientInformation::setNext(ClientInformation *next){
-  this->nexte = next;
-  return true;
-}
-
-ClientInformation *ClientInformation::insertAfter(ClientInformation *ins){
-  this->nexte->setPrev(ins);
-  ins->setNext(this->nexte);
-  ins->setPrev(this);
-  this->nexte = ins;
-  return ins;
-}
-
-ClientInformation *ClientInformation::insertBefore(ClientInformation *ins){
-  this->prev()->setNext(ins);
-  ins->setPrev(this->preve);
-  this->preve=ins;
-  ins->setNext(this);
-  return ins;
-}
-
-void ClientInformation::setID(int clientID){
-  clientID_ = clientID;
-}
-void ClientInformation::setPeer(ENetPeer *peer){
-  peer_ = peer;
-}
-
-void ClientInformation::setGamestateID(int id){
-  gamestateID_=id;
-}
-
-int ClientInformation::getID(){
-  return clientID_;
-}
-ENetPeer *ClientInformation::getPeer(){
-  return peer_;
-}
-
-int ClientInformation::getGamestateID(){
-  return gamestateID_;
-}
-
-ClientInformation *ClientInformation::insertBack(ClientInformation *ins){
-  ClientInformation *temp = this;
-  while(temp->next()!=0){
-    temp = temp->next();
-  }
-  temp->setNext(ins);
-  ins->setPrev(temp);
-  return ins;
-}
-
-bool ClientInformation::removeClient(int clientID){
-  ClientInformation *temp = this;
-  while(temp!=0 && temp->getID()!=clientID)
-    temp = temp->next();
-  if(temp==0)
-    return false;
-  delete temp;
-  return true;
-}
-
-bool ClientInformation::removeClient(ENetPeer *peer){
-  ClientInformation *temp = this;
-  while(temp!=0){
-    if(!temp->head)
-      if(temp->getPeer()->address.host==peer->address.host && temp->getPeer()->address.port==peer->address.port)
-        break;
-    temp = temp->next();
-  }
-  if(temp==0)
-    return false;
-  delete temp;
-  return true;
-}
-
-/**
- * This function goes forward through the list and looks for an element with clientID
- * This function should only be applied to the head of the list
- * @param clientID id to look for
- * @return pointer to the element in the list or 0 if the search was unsuccessfull
- */
-ClientInformation *ClientInformation::findClient(int clientID, bool look_backwards){
-  ClientInformation *temp = this;
-  if (temp->head)
-    temp=temp->next();
-  while(temp!=0 && temp->getID()!=clientID){
-    temp = temp->next();
-  }
-  // returns 0 if nothing has been found
-  return temp;
-}
-
-/**
- * This function goes forward through the list and looks for an element with clientID
- * This function should only be applied to the head of the list
- * @param peer peer to look for
- * @return pointer to the element in the list
- */
-ClientInformation *ClientInformation::findClient(ENetAddress *address, bool look_backwards){
-  ClientInformation *temp = this;
-  while(temp!=0){
-    if(temp->head){
-      temp = temp->next();
-      continue;
-    }
-    if(temp->getPeer()->address.host==address->host && temp->getPeer()->address.port == address->port)
-      break;
-    temp = temp->next();
-  }
-  // returns 0 if nothing has been found
-  return temp;
-}
-
-void ClientInformation::setSynched(bool s){
-  synched_=s;
-}
-bool ClientInformation::getSynched(){
-  return synched_;
-}
-
-}
Index: code/branches/FICN/src/network/ClientInformation.h
===================================================================
--- code/branches/FICN/src/network/ClientInformation.h	(revision 774)
+++ code/branches/FICN/src/network/ClientInformation.h	(revision 777)
@@ -14,53 +14,54 @@
 
 #include <enet/enet.h>
-#include <iostream> //debug
+
+#include "NetworkPrereqs.h"
 
 #define GAMESTATEID_INITIAL -1
 
-namespace network {
+namespace network
+{
+  /**
+  * This class implements a list for client informations
+  * @author Oliver Scheuss
+  */
+  class ClientInformation{
+  public:
+    ClientInformation();
+    ClientInformation(bool head);
+    //   ClientInformation(ClientInformation *prev, ClientInformation *next);
+    //   ClientInformation(ClientInformation *prev);
+    ~ClientInformation();
+    ClientInformation *next();
+    ClientInformation *prev();
+    bool setNext(ClientInformation *next);
+    bool setPrev(ClientInformation *prev);
+    ClientInformation *insertAfter(ClientInformation *ins);
+    ClientInformation *insertBefore(ClientInformation *ins);
+    ClientInformation *insertBack(ClientInformation *ins);
+    void setID(int clientID);
+    void setPeer(ENetPeer *peer);
+    void setGamestateID(int id);
+    int getID();
+    ENetPeer *getPeer();
+    int getGamestateID();
+    bool removeClient(int clientID);
+    bool removeClient(ENetPeer *peer);
+    ClientInformation *findClient(int clientID, bool look_backwards=false);
+    ClientInformation *findClient(ENetAddress *address, bool look_backwards=false);
 
-/**
- * This class implements a list for client informations
- * @author Oliver Scheuss
-*/
-class ClientInformation{
-public:
-  ClientInformation();
-  ClientInformation(bool head);
-//   ClientInformation(ClientInformation *prev, ClientInformation *next);
-//   ClientInformation(ClientInformation *prev);
-  ~ClientInformation();
-  ClientInformation *next();
-  ClientInformation *prev();
-  bool setNext(ClientInformation *next);
-  bool setPrev(ClientInformation *prev);
-  ClientInformation *insertAfter(ClientInformation *ins);
-  ClientInformation *insertBefore(ClientInformation *ins);
-  ClientInformation *insertBack(ClientInformation *ins);
-  void setID(int clientID);
-  void setPeer(ENetPeer *peer);
-  void setGamestateID(int id);
-  int getID();
-  ENetPeer *getPeer();
-  int getGamestateID();
-  bool removeClient(int clientID);
-  bool removeClient(ENetPeer *peer);
-  ClientInformation *findClient(int clientID, bool look_backwards=false);
-  ClientInformation *findClient(ENetAddress *address, bool look_backwards=false);
-  
-  void setSynched(bool s);
-  bool getSynched();
-  
-  bool head;
-  
-private:
-  ClientInformation *preve;
-  ClientInformation *nexte;
-  //actual information:
-  ENetPeer *peer_;
-  int clientID_;
-  int gamestateID_;
-  bool synched_;
-};
+    void setSynched(bool s);
+    bool getSynched();
+
+    bool head;
+
+  private:
+    ClientInformation *preve;
+    ClientInformation *nexte;
+    //actual information:
+    ENetPeer *peer_;
+    int clientID_;
+    int gamestateID_;
+    bool synched_;
+  };
 
 }
